program generate_connected_graph;

{$APPTYPE CONSOLE}

type
  tree = ^node;
  node = record
    x: integer;
    left, right: tree;
    level: integer;
  end;

var bottom: tree;
    edges: array[0..110000] of tree;
    i, n, m, a, b, temp: integer;
    tempok: boolean;

procedure skew (var apar: tree);
var tempi: tree;
begin
  if apar.left.level = apar.level then
  begin
    tempi := apar;
    apar := apar.left;
    tempi.left := apar.right;
    apar.right := tempi;
  end;
end;

procedure split (var apar: tree);
var tempi: tree;
begin
  if apar.right.right.level = apar.level then
  begin
    tempi := apar;
    apar := apar.right;
    tempi.right := apar.left;
    apar.left := tempi;
    inc(apar.level);
  end;
end;

procedure insert (var targ: tree; xpar: integer; var ok: boolean);
begin
  if targ = bottom then
  begin
    new (targ);
    targ.x := xpar;
    targ.left := bottom;
    targ.right := bottom;
    targ.level := 1;
    ok := true;
  end
  else
  begin
    if xpar < targ.x then insert (targ.left, xpar, ok)
    else if xpar > targ.x then insert (targ.right, xpar, ok)
    else ok := false;

    skew(targ);
    split(targ);
  end;
end;

function find (var targ: tree; xpar: integer): boolean;
begin
  if targ = bottom then begin result := false; exit; end;
  if targ.x = xpar then begin result := true; exit; end;
  if targ.x < xpar then
    result := find (targ.right, xpar)
  else
    result := find (targ.left, xpar);
end;

begin
  assign (output, paramstr(1)); rewrite (output);

  val (paramstr(2), n, temp);
  val (paramstr(3), m, temp);
  val (paramstr(4), randseed, temp);

  writeln (n, ' ', m);

  new (bottom);
  bottom.x := 0;
  bottom.left := bottom;
  bottom.right := bottom;
  bottom.level := 0;

  for i := 0 to 100000 do edges[i] := bottom;

  for i := 2 to n do 
  begin
    a := round(random*(i-2)) + 1;
    insert (edges[i], a, tempok);
    writeln (i, ' ', a, ' ', round(random*999) + 1);
  end;

  for i := 1 to m - n + 1 do
  begin
    repeat
      a := round(random*(n-1)) + 1;
      b := round(random*(n-1)) + 1;
    until (a <> b) and (not find(edges[a], b)) and (not find(edges[b], a));

    writeln (a, ' ', b, ' ', round(random*999)+1);
    insert (edges[a], b, tempok);
  end;

  close (output);
end.